#! /usr/bin/env python

# Loads properties from a standard Paraxip properties file into a database
# Appends to existing property values if database already exists


# Standard modules
import sys

# Non-standard modules
import sqlalchemy
import elixir
from odict import odict

# Impl. modules
from paraxip.infra.Properties import Properties
from paraxip.infra.ConfigPropertiesModel import Property, PropertyValue

            
if __name__=="__main__":

  if len(sys.argv) < 3 or len(sys.argv) > 4:
    print 'Usage: ' + sys.argv[0] + ' <properties file> <database url> ' + \
        '[<propertyset name>]'
  else:
    prop_file_name = sys.argv[1]
    elixir.metadata.bind = sqlalchemy.create_engine(sys.argv[2], echo=False)
    elixir.setup_all()
    elixir.create_all()

    # Third-party Java-style properties loader/saver
    props_from_file = Properties()
    # Using an ordered dictionary inseatd of native dict to keep original 
    #   properties order
    props_from_file._props = odict()
    props_from_file.load(open(prop_file_name))

    # Iterate thru key, value from properties file
    for key, value in props_from_file.getPropertyDict().items():
      p = Property.get_by(name=key)
      if p is None:
        # Unknown property, add to db
        p = Property(name=key, useParamDB = True)
      # Add new property value
      pv = PropertyValue(property=p, value=value, comment='Imported from %s' % \
          prop_file_name)
      if len(sys.argv) == 4:
        pv.set = sys.argv[3]

  elixir.session.flush()  
  elixir.session.commit()## !!MIRROR FILE, DO NOT MODIFY!!
