<?xml version="1.0" encoding="utf-8"?>

<!--

This xslt stylesheet is used to generate python code base on the supplied
xml file. When invoked the stylesheet required an initVersion parameter
which is the initial version of the update process.

-->

<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "xml" indent="yes"/> 

<!-- This template copy all the elements and their attributes -->
<xsl:template match="node()|@*">
  <xsl:copy>
    <xsl:apply-templates select="node()|@*"/>
  </xsl:copy>
</xsl:template>


<xsl:template match="/">
  <xsl:call-template name="searchJob">
    <xsl:with-param name="outFileName" select="$fileName"/>
  </xsl:call-template>
</xsl:template>


<!-- 
This template search for a converter element with an attribute
equal to the srcVersion parameter an apply other template to it.
If more then one converter element match or 0 return an error message.
-->
<xsl:template name="searchJob">
  <xsl:param name="outFileName"/>
  <xsl:if test="count(//pbxConfiguration/job[@outputFilename=$outFileName]) = 0">
    <xsl:message terminate="yes">
      <xsl:text>Invalid file name: Can't find a outputFilename attribute matching </xsl:text>
      <xsl:value-of select="$fileName"/>
      <xsl:text> in pbx configuration file</xsl:text>
    </xsl:message>
  </xsl:if>
  <xsl:if test="count(//pbxConfiguration/job[@outputFilename=$outFileName]) &gt; 1">
    <xsl:message terminate="yes">
      <xsl:text>Invalid pbx configuration file: Found more then one outputFilename attribute matching </xsl:text>
      <xsl:value-of select="$outFileName"/>
    </xsl:message>
  </xsl:if>
  <xsl:apply-templates select="//pbxConfiguration/job[@outputFilename=$outFileName]/data"/>
</xsl:template>


<xsl:template match="data">
  <xsl:apply-templates select="node()|@*"/>
</xsl:template>


</xsl:stylesheet> 
