<?xml version="1.0" encoding="utf-8"?>

<!--

This xslt stylesheet is used to generate python code base on the supplied
pbx xml file.

-->

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "text"/> 


<xsl:template match="pbxConfiguration">
  <xsl:call-template name="writeHeader"/>
  <xsl:for-each select="descendant::job">
    <xsl:text>
  jobRunner.addJob(ExtractConfigData(pbxConfigMan, jobStatus=jobStatus, inputFilename=pbxConfigMan.getPbxFileName(), </xsl:text> 
    <xsl:for-each select="@*[name(.)!='converter' and name(.)!='inputFilename']">
      <xsl:value-of select="name(.)"/>="<xsl:value-of select="."/>
      <xsl:if test="position()!=last()">
        <xsl:text>", </xsl:text>
      </xsl:if>
    </xsl:for-each>
    <xsl:text>"))</xsl:text>
  </xsl:for-each>
  <xsl:text>

  jobRunner.addJob(swapJob)
  jobRunner.addJob(smartUpdateJob)
  jobRunner.addJob(swapJob)
  </xsl:text>
  <xsl:apply-templates select="descendant::job"/>
  <xsl:text>

  jobRunner.addJob(swapJob)
  jobRunner.addJob(finalModeJob)
  </xsl:text>
  <xsl:for-each select="descendant::job">
    <xsl:text>
  jobRunner.addJob(CopyConfig(pbxConfigMan, jobStatus=jobStatus, </xsl:text> 
    <xsl:for-each select="@*[name(.)!='converter']">
      <xsl:value-of select="name(.)"/>="<xsl:value-of select="."/>
      <xsl:if test="position()!=last()">
        <xsl:text>", </xsl:text>
      </xsl:if>
    </xsl:for-each>
    <xsl:text>"))</xsl:text>
  </xsl:for-each>
  <xsl:call-template name="writeFooter"/>
</xsl:template>


<!--
When a match is made on a job element the @converter
template must be applied first. Then the rest of the 
attributes are transformed to:
attribute_name="attribute_value", 
If it's the last attribute the function call is closed
with ") instead of ", like the others attributes.
-->
<xsl:template match="job">
  <xsl:apply-templates select="@converter"/>
  <xsl:for-each select="@*[not(name(.)='converter')]">
    <xsl:value-of select="name(.)"/>="<xsl:value-of select="."/>
    <xsl:if test="position()!=last()">
      <xsl:text>", </xsl:text>
    </xsl:if>
  </xsl:for-each>
  <xsl:text>"))</xsl:text>
</xsl:template>



<!--
A converter attribute mean that a job corresponding to
the value of this attribute must be added to the job runner.
-->
<xsl:template match="@converter">
  <xsl:text>
  jobRunner.addJob(</xsl:text>
  <xsl:value-of select="."/>
  <xsl:text>(pbxConfigMan, jobStatus=jobStatus, </xsl:text>
</xsl:template>


<!--
Header of the .py generated.
-->
<xsl:template name="writeHeader">
  <xsl:text>

from paraxip.pbx_configurator.PbxConverter import *

def addJobs(jobRunner, jobStatus, pbxConfigMan, swapJob, smartUpdateJob, finalModeJob):
  </xsl:text>
</xsl:template>

<!--
End of the .py generated.
-->
<xsl:template name="writeFooter">
  <xsl:text>
  
  return True</xsl:text>
</xsl:template>

</xsl:stylesheet>
