<?xml version="1.0" encoding="utf-8"?>

<xsl:stylesheet version="1.0"
xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
<xsl:output method = "text"/>
<xsl:strip-space elements="*"/>

<!--This template force the script to match on elements and apply a template on
a specific attribute. In our case, @value attribute. By default, we can not
match on attributes. The second "apply-templates" call is used as a
"continue".-->
<xsl:template match="*">
  <xsl:apply-templates select="@value"/>
  <xsl:apply-templates/>
</xsl:template>

<!--When the current element attribute has a value attribute, we start by
looking if is defined or not in the configuration. If it is not defined we
at a comment sign ('#'). Then, for each of the ancestors (except the
configuration element) of the current node, we write down the name of this
ancestor and add a '.' except for the last ancestor where we add a '='
sign. We conclude by adding a carriage return at the end of the line.-->
<xsl:template match="@value">
  <xsl:if test="parent::*/@defined='false'">
    <xsl:text>#</xsl:text>
  </xsl:if>
  <xsl:for-each select="(ancestor::*[not(name()='configuration')])">
    <xsl:value-of select="name(.)"/>
    <xsl:choose>
      <xsl:when test="position()=last()">
        <xsl:text>=</xsl:text>
      </xsl:when>
      <xsl:otherwise>
        <xsl:text>.</xsl:text>
      </xsl:otherwise>
    </xsl:choose>
  </xsl:for-each>
  <xsl:value-of select="."/>
  <xsl:text>&#10;</xsl:text> <!--add cr at the end of the line-->
</xsl:template>

</xsl:stylesheet>