#!/bin/sh
#
# This script is used during during NBE pre-installation
#


# Create link to be used by the gateway manager
ln -sf XXX_PREFIX_XXX/bin/netborder-py-wrapper-app XXX_PREFIX_XXX/bin/netborder-gateway-manager

# Replace the XXX_PARAXIP_INSTDIR_XXX in linux scripts
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/install-gateway-service.sh
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/uninstall-gateway-service.sh
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/install-gateway-manager-service.sh
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/uninstall-gateway-manager-service.sh
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/netborder-gateway.conf
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/netborder-gateway-manager.conf
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/netborder-gateway
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/netborder-gateway-manager
#sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/install-drivers.sh
#sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/uninstall-drivers.sh
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/configure-snmpd.sh
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/uninstall-cron-job.sh
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/install-cron-job.sh
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/update-faillure-automatic-restart.sh
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/linux/netborder-gateway-cron-job.sh 

# Make replacements in properties files
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/config/*.properties
sed -si 's|XXX_WEBSERVER_PORT_XXX|7782|g' XXX_PREFIX_XXX/config/*.properties
sed -si 's|XXX_RTP_UDP_PORT_RANGE_XXX|14000:54000|g' XXX_PREFIX_XXX/config/*.properties

# Make sure the WEB server use the propertes gateway service name
sed -si 's|\(netborder\.oamWebServer\.gwServiceName=\).*$|\1netborder-gateway|g'  XXX_PREFIX_XXX/config/oamWebServer.properties

# Make substitutions in WEB server files
rm -f XXX_PREFIX_XXX/bin/shttpd.conf
mv  XXX_PREFIX_XXX/bin/shttpd-installer.conf XXX_PREFIX_XXX/bin/shttpd.conf
sed -si 's|XXX_INSTDIR_XXX|XXX_PREFIX_XXX|g' XXX_PREFIX_XXX/bin/shttpd.conf
sed -si 's|XXX_WEBSERVER_PORT_XXX|7782|g' XXX_PREFIX_XXX/bin/shttpd.conf
sed -si 's|XXX_WEB_SERVICE_PORT_XXX|18086|g' XXX_PREFIX_XXX/bin/shttpd.conf

# Generate gateway manager parameter DB
XXX_PREFIX_XXX/bin/netborder-gateway-manager \
    --save-parameter-db-as-xml-file \
    "XXX_PREFIX_XXX/config/netborder-gateway-manager-paramDefs.xml" \
    --class-name paraxip.oamgui.TurboGearsJRunnable.TurboGearsJRunnable \
    --global-config "XXX_PREFIX_XXX/config/oam.install.properties" \
    --global-config "XXX_PREFIX_XXX/config/oamWebServer.properties"

# Consolidate Gateway Manager properties into a single oamWebServer.properties
# files
XXX_PREFIX_XXX/bin/netborder-properties-editor \
    --param-db "XXX_PREFIX_XXX/config/netborder-gateway-manager-paramDefs.xml" \
    -c "add-defaults" -o "XXX_PREFIX_XXX/config/oamWebServer.properties"  \
    "XXX_PREFIX_XXX/config/oam.install.properties" \
    "XXX_PREFIX_XXX/config/oamWebServer.properties"

# Update gateway manager service .conf file to use the consolidated 
# oamWebServer.properties file
sed -si 's|--global-config.*/config/oam.install.properties||g' \
    "XXX_PREFIX_XXX/linux/netborder-gateway-manager.conf"
 
# Consolidate Gateway properties
XXX_PREFIX_XXX/bin/netborder-properties-editor \
    --param-db "XXX_PREFIX_XXX/config/netborder-gateway-paramDefs.xml" \
    -c "add-defaults" -o "XXX_PREFIX_XXX/config/gw.properties"  \
    "XXX_PREFIX_XXX/config/install.properties" \
    "XXX_PREFIX_XXX/config/gw_internal.properties" \
    "XXX_PREFIX_XXX/config/gw.properties"

# Backup consolidated file
mv  "XXX_PREFIX_XXX/config/install.properties" \
    "XXX_PREFIX_XXX/config/install.properties.bak" 
mv  "XXX_PREFIX_XXX/config/gw_internal.properties" \
    "XXX_PREFIX_XXX/config/gw_internal.properties.bak" 

# Add the gateway as a service 
XXX_PREFIX_XXX/linux/install-gateway-service.sh

# Install Sangoma drivers
#XXX_PREFIX_XXX/linux/install-drivers.sh

# Install and start the gateway manager 
XXX_PREFIX_XXX/linux/install-gateway-manager-service.sh
service netborder-gateway-manager start

# Configure snmpd service to accept subagents
XXX_PREFIX_XXX/linux/configure-snmpd.sh