//------------------------------------------------
// Digital Physical T1 Config form
// -----------------------------------------------
Ext.namespace("Paraxip.config.physConfig");

var frmDigitalT1PhysConf = new Ext.FormPanel({
  title         : "Digital Physical Configuration",
  frame         : true,
  header        : false,
  id            : "frmDigitalT1PhysConf",
  autoScroll    : true,
  layout        : 'accordion',
  layoutConfig  : {
    activeItem  : 0
  },
  defaults      : {
    layout: 'form',
    style: 'text-align:left;',
    labelWidth: 150,
    bodyStyle: 'padding:5px;',
    width: 500,
    autoHeight: true,
    fill: true
  },
  buttonAlign   : "right",
  buttons       : [{
    id: "Paraxip.config.physConfig.digitalT1AssignedIf",
    text: 'Assigned interface(s)',
    listeners: {'click':function(){
        configId = id_textT1.getValue();
        unassignedInterfacesGrid.getStore().load({
           params: {'id':configId}
        });
        assignedInterfacesGrid.getStore().load({
           params: {'id':configId}
        });
        assignInterfacesWindow.show();
      }
    }
  },{
    id: "Paraxip.config.physConfig.digitalT1SaveButton",
    text: 'Save',
    listeners: {'click':saveConfig}
  },{
    id: "Paraxip.config.physConfig.digitalT1CancelButton",
    text: 'Cancel',
    listeners: {'click':physConfCancel}
  }]
});

var t1ConfigPanel = new Ext.Panel({
  id    : 't1ConfigPanel',
  name  : 'config',
  title : 'Configuration Info',
  items : [{
    xtype: 'textfield',
    id: 't1NodeId',
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  }]
});

var digitalT1Panel = new ParaxipPanelWithHelp({
  id    : 'digitalT1Panel ',
  name  : 'digitalT1',
  title : 'Digital T1 Configuration',
  helpText : "t1ParametersdigitalT1"
});

var DChannelT1Panel = new Ext.Panel({
  id    : 'DChannelT1Panel',
  name  : 'DChannelT1',
  title : 'DChannel T1 Configuration'
});

var audioT1Panel = new Ext.Panel({
  id    : 'audioT1Panel',
  name  : 'audio',
  title : 'Audio Configuration'
});

var echoT1Panel = new ParaxipPanelWithHelp({
  id    : 'echoT1Panel',
  name  : 'EchoCancellation',
  title : 'Echo Cancellation Configuration',
  helpText: "HardwareEchoCancellationEchoCancellation"
});

var acousticT1Panel = new ParaxipPanelWithHelp({
  id    : 'acousticT1Panel',
  name  : 'AcousticEchoCancellation',
  title : 'Acoustic Echo Cancellation Configuration',
  helpText: "HardwareAcousticEchoCancellationAcousticEchoCancellation"
});

var levelT1Panel = new ParaxipPanelWithHelp({
  id    : 'levelT1Panel',
  name  : 'LevelControl',
  title : 'Level Control Configuration',
  helpText: "HardwareLevelControlLevelControl"
});

var backgroundT1Panel = new ParaxipPanelWithHelp({
  id    : 'backgroundT1Panel',
  name  : 'BackgroundNoiseAttenuation',
  title : 'Background Noise Attenuation Configuration',
  helpText: "HardwareBackgroundNoiseRemovalBackgroundNoiseAttenuation"
});

var dtmfT1Panel = new ParaxipPanelWithHelp({
  id    : 'dtmfT1Panel',
  name  : 'DTMFRemoval',
  title : 'DTMF Removal Configuration',
  helpText: "HardwareDTMFRemovalDTMFRemoval"
});

/**************************
  Digital T1 Configuration
***************************/

var id_textT1 = new Ext.form.TextField({
  id          : 'id_textT1',
  fieldLabel  : "ID",
  name        : "id",
  disabled    : true,
  width       : 162
});

var name_textT1 = new Ext.form.TextField({
  id          : 'name_textT1',
  fieldLabel  : "Display Name",
  name        : "displayName",
  width       : 162
});

var digitalT1_label = new Ext.form.Label({
  id        : "Paraxip.config.physConfig.digitalT1Label",
  text      : "Digital T1 Physical Configuration",
  helpText  : "t1ParametersdigitalT1",
  style     : 'line-height:40px;'
});

var framingT1_select = new Ext.form.ComboBox({
  id              : 'framingT1_selection',
  name            : 'framing',
  fieldLabel      : "Framing",
  helpText        : "t1ParametersdigitalT1framing",
  store           : ['ESF',/*'ESF_Japan',*/'D4'], //ESF_Japan not supported for now
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

var line_encT1_select = new Ext.form.ComboBox({
  id              : 'line_encT1_selection',
  name            : 'lineEncoding',
  fieldLabel      : "Line Encoding",
  helpText        : "t1ParametersdigitalT1lineEncoding",
  store           : ['AMI','B8ZS'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

var lboT1_select = new Ext.form.ComboBox({
  id              : 'lboT1_selection',
  name            : 'LBO',
  fieldLabel      : "LBO",
  helpText        : "t1ParametersdigitalT1LBO",
  store           : ['0dB','-7.5dB','-15dB','-22.5dB',
                     '0-110feet','110-220feet','220-330feet',
                     '330-440feet','440-550feet','550-660feet'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

var clockingT1_select = new Ext.form.ComboBox({
  id              : 'clockingT1_selection',
  name            : 'clocking',
  fieldLabel      : "Clocking",
  helpText        : "clockingclocking",
  store           : ['TERMINAL','NETWORK'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  disabled        : false,
  width           : 145,
  minListWidth    : 145
});
/*
var loopback_modeT1_select = new Ext.form.ComboBox({
  id              : 'loopback_modeT1_selection',
  name            : 'loopbackMode',
  fieldLabel      : "Loopback Mode",
  helpText        : "t1ParametersdigitalT1loopbackMode",
  store           : ['DISABLED'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});
*/
var dChannelT1_label = new Ext.form.Label({
  id      : "Paraxip.config.physConfig.dchannelT1Label"
  ,text   : "D-Channel T1 Configuration"
  ,style  : 'line-height:40px;'
});

var dChannelT1_disable = new Ext.form.ComboBox({
  id                : 'disableDChannelT1'
  ,fieldLabel       : 'Enable/Disable D-Channel'
  ,name             : 'disableDChannel'
  ,store            : ['ENABLED','DISABLED']
  ,forceSelection   : true
  ,triggerAction    : 'all'
  ,mode             : 'local'
  ,typeAhead        : true
  ,selectOnFocus    : true
  ,width            : 145
  ,minListWidth     : 145
});

dChannelT1_disable.on('select',isDChannelEnabled,dChannelT1_disable);

// Max value is 24 and Min is 1
var channelT1_idx_text = new Ext.form.TextField({
  id            : 'channelT1_idx_text'
  ,fieldLabel   : "D-Channel Index"
  ,helpText     : "t1ParametersdigitalT1DChannelT1channelIndex"
  ,name         : "channelIndex"
  ,helpText     : "t1ParametersdigitalT1DChannelT1channelIndex"
  ,disabled     : true
  ,width        : 162
  ,value        : 24
});

// Max is 4096 and min 256
var mtu_sizeT1_text = new Ext.form.NumberField({
  id            : 'mtu_sizeT1_text'
  ,fieldLabel   : "MTU Size"
  ,name         : "mtuSize"
  ,helpText     : "DChannelMtuSizemtuSize"
  ,value        : 2048
  ,width        : 162
});

var record_to_pcap_fileT1 = new Ext.form.ComboBox({
  id                : 'record_to_pcap_fileT1'
  ,fieldLabel       : "Record To Pcap File"
  ,name             : 'RecordToPcapFile'
  ,store            : ['YES','NO']
  ,forceSelection   : true
  ,helpText         : "DChannelRecordToPcapFileRecordToPcapFile"
  ,triggerAction    : 'all'
  ,mode             : 'local'
  ,typeAhead        : true
  ,selectOnFocus    : true
  ,width            : 145
  ,minListWidth     : 145
  ,value            : 'NO'
});

var pcap_files_folderT1 = new Ext.form.TextField({
  id            : 'pcap_files_folderT1'
  ,fieldLabel   : "Pcap Files Folder"
  ,helpText     : "DChannelPcapFilesFolderPcapFilesFolder"
  ,name         : "pcap_files_folderT1"
  ,disabled     : true
  ,width        : 162
  ,value        : "/logs/dchan-pcap-recording/"
});

pcap_files_folderT1.on('render',function(){
  isDChannelEnabled.call(dChannelT1_disable);
});

var defaultPcmLawT1_select =  createPcmLawSelection({
  id  : 'defaultPcmLawT1_selection'
});

var voicePacketLengthInMsT1_text = createVoicePacketText({
  id  : 'voicePacketLengthInMsT1_text'
});

var optimalTxBufferLevelT1_text = createOptimalTxBufferLevelText({
  id  : 'optimalTxBufferLevelT1_text'
});



var toneSetAttributesT1_select = createToneSetAtributesSelection({
  id  : 'toneSetAttributesT1_select'
});

var ecT1_type_select = createEcTypeSelect({
  id  : 'ecT1_type_selection'
});

var ecT1_mode_select = createEcModeSelect({
  id  : 'ecT1_mode_selection'
});

var ecT1_comfortNoiseMode_select = createEcComfortNoiseSelect({
  id  : 'ecT1_comfortNoiseMode_selection'
});

var ecT1_tailDisplacementInMs_text = createEcTailText({
  id  : 'ecT1_tailDisplacementInMs_text'
});

var ecT1_doubleTalkBehavior_select = createEcDoubleTalkSelect({
  id  : 'ecT1_doubleTalkBehavior_selection'
});

var aecT1_type_select = createAecTypeSelect({
  id  : 'aecT1_type_selection'
});

var aecT1_mode_select = createAecModeSelect({
  id  : 'aecT1_mode_selection'
});

var levelT1_type_select = createLevelTypeSelect({
  id  : 'levelT1_type_selection'
});

var levelT1_direction_select = createLevelDirectionSelect({
  id  : 'levelT1_direction_selection'
});

var levelT1_mode_select = createLevelModeSelect({
  id        : 'levelT1_mode_selection',
  listeners : {
    'select': levelControlVisibleFields,
    scope   : frmDigitalT1PhysConf
  }
});

var levelT1_targetLevelIndBM0_text = createLevelTargetText({
  id  : 'levelT1_targetLevelIndBM0_text'
});

var levelT1_gainIndB_text = createLevelGainText({
  id  : 'levelT1_gainIndB_text'
});

var bnaT1_type_select = createBnaTypeSelect({
  id  : 'bnaT1_type_selection'
});

var bnaT1_direction_select = createBnaDirectionSelect({
  id  : 'bnaT1_direction_selection'
});

var bnaT1_mode_select = createBnaModeSelect({
  id  : 'bnaT1_mode_selection'
});

var bnaT1_attenuationIndB_select = createBnaAttenuationSelect({
  id  : 'bnaT1_attenuationIndB_selection'
});

var dtmfT1_type_select = createDtmfTypeSelect({
  id  : 'dtmfT1_type_selection'
});

var dtmfT1_direction_select = createDtmfDirectionSelect({
  id  : 'dtmfT1_direction_selection'
});

var dtmfT1_mode_select = createDtmfModeSelect({
  id  : 'dtmfT1_mode_selection'
});

t1ConfigPanel.add(id_textT1);
t1ConfigPanel.add(name_textT1);
frmDigitalT1PhysConf.add(t1ConfigPanel);

//frmDigitalT1PhysConf.add(digitalT1_label);
digitalT1Panel.add(framingT1_select);
digitalT1Panel.add(line_encT1_select);
digitalT1Panel.add(lboT1_select);
digitalT1Panel.add(clockingT1_select);
//digitalT1Panel.add(loopback_modeT1_select);
frmDigitalT1PhysConf.add(digitalT1Panel);

//frmDigitalT1PhysConf.add(dChannelT1_label);
DChannelT1Panel.add(dChannelT1_disable);
DChannelT1Panel.add(channelT1_idx_text);
DChannelT1Panel.add(mtu_sizeT1_text);
DChannelT1Panel.add(record_to_pcap_fileT1);
DChannelT1Panel.add(pcap_files_folderT1);
frmDigitalT1PhysConf.add(DChannelT1Panel);

//frmDigitalT1PhysConf.add(createAudioLabel());
audioT1Panel.add(defaultPcmLawT1_select);
audioT1Panel.add(voicePacketLengthInMsT1_text);
audioT1Panel.add(toneSetAttributesT1_select);
audioT1Panel.add(optimalTxBufferLevelT1_text);
frmDigitalT1PhysConf.add(audioT1Panel);

//frmDigitalT1PhysConf.add(createEchoCancelLabel());
echoT1Panel.add(ecT1_type_select);
echoT1Panel.add(ecT1_mode_select);
echoT1Panel.add(ecT1_comfortNoiseMode_select);
echoT1Panel.add(ecT1_tailDisplacementInMs_text);
echoT1Panel.add(ecT1_doubleTalkBehavior_select);
frmDigitalT1PhysConf.add(echoT1Panel);

//frmDigitalT1PhysConf.add(createAcousticLabel());
acousticT1Panel.add(aecT1_type_select);
acousticT1Panel.add(aecT1_mode_select);
frmDigitalT1PhysConf.add(acousticT1Panel);

//frmDigitalT1PhysConf.add(createLevelControlLabel());
levelT1Panel.add(levelT1_type_select);
levelT1Panel.add(levelT1_direction_select);
levelT1Panel.add(levelT1_mode_select);
levelT1Panel.add(levelT1_targetLevelIndBM0_text);
levelT1Panel.add(levelT1_gainIndB_text);
frmDigitalT1PhysConf.add(levelT1Panel);

//frmDigitalT1PhysConf.add(createBackgroundLabel());
backgroundT1Panel.add(bnaT1_type_select);
backgroundT1Panel.add(bnaT1_direction_select);
backgroundT1Panel.add(bnaT1_mode_select);
backgroundT1Panel.add(bnaT1_attenuationIndB_select);
frmDigitalT1PhysConf.add(backgroundT1Panel);

//frmDigitalT1PhysConf.add(createDTMFRemovalLabel());
dtmfT1Panel.add(dtmfT1_type_select);
dtmfT1Panel.add(dtmfT1_direction_select);
dtmfT1Panel.add(dtmfT1_mode_select);
frmDigitalT1PhysConf.add(dtmfT1Panel);

//-----------------------------------------------
// Digital Physical E1 Config form
// -----------------------------------------------
var frmDigitalE1PhysConf = new Ext.FormPanel({
  title           : "Digital Physical Configuration",
  frame           : true,
  header          : false,
  id              : "frmDigitalE1PhysConf",
  autoScroll      : true,
  layout        : 'accordion',
  layoutConfig  : {
    activeItem  : 0
  },
  defaults    : {
    layout: 'form',
    style: 'text-align:left;',
    labelWidth: 150,
    bodyStyle: 'padding:5px;',
    width: 500,
    autoHeight: true,
    fill: true
  },
  buttonAlign     : "right",
  buttons         : [{
    id: "Paraxip.config.physConfig.digitalE1AssignedIF",
    text: 'Assigned interface(s)',
    listeners: {'click':function(){
        configId = id_textE1.getValue();
        unassignedInterfacesGrid.getStore().load({
           params: {'id':configId}
        });
        assignedInterfacesGrid.getStore().load({
           params: {'id':configId}
        });
        assignInterfacesWindow.show();
      }
    }
  },{
    id: "Paraxip.config.physConfig.digitalE1SaveButton",
    text: 'Save',
    listeners: {'click':saveConfig}
  },{
    id: "Paraxip.config.physConfig.digitalE1CancelButton",
    text: 'Cancel',
    listeners: {'click':physConfCancel}
  }]
});

var e1ConfigPanel = new Ext.Panel({
  id    : 'e1ConfigPanel',
  name  : 'config',
  title : 'Configuration Info',
  items : [{
    xtype: 'textfield',
    id: 'e1NodeId',
    name: 'nodeId',
    hidden: true,
    hideLabel: true
  }]
});

var digitalE1Panel = new Ext.Panel({
  id    : 'digitalE1Panel ',
  name  : 'digitalE1',
  title : 'Digital E1 Configuration'
});

var DChannelE1Panel = new Ext.Panel({
  id    : 'DChannelE1Panel',
  name  : 'DChannelE1',
  title : 'DChannel E1 Configuration'
});

var audioE1Panel = new Ext.Panel({
  id    : 'audioE1Panel',
  name  : 'audio',
  title : 'Audio Configuration'
});

var echoE1Panel = new Ext.Panel({
  id    : 'echoE1Panel',
  name  : 'EchoCancellation',
  title : 'Echo Cancellation Configuration'
});

var acousticE1Panel = new Ext.Panel({
  id    : 'acousticE1Panel',
  name  : 'AcousticEchoCancellation',
  title : 'Acoustic Echo Cancellation Configuration'
});

var levelE1Panel = new Ext.Panel({
  id    : 'levelE1Panel',
  name  : 'LevelControl',
  title : 'Level Control Configuration'
});

var backgroundE1Panel = new Ext.Panel({
  id    : 'backgroundE1Panel',
  name  : 'BackgroundNoiseAttenuation',
  title : 'Background Noise Attenuation Configuration'
});

var dtmfE1Panel = new Ext.Panel({
  id    : 'dtmfE1Panel',
  name  : 'DTMFRemoval',
  title : 'DTMF Removal Configuration'
});

/**************************
  Digital E1 Configuration
***************************/
var id_textE1 = new Ext.form.TextField({
  id          : 'id_textE1',
  fieldLabel  : "ID",
  name        : "id",
  disabled    : true,
  width       : 162
});

var name_textE1 = new Ext.form.TextField({
  id          : 'name_textE1',
  fieldLabel  : "Display Name",
  name        : "displayName",
  width       : 162
});

var digitalE1_label = new Ext.form.Label({
  id        : "Paraxip.config.physConfig.digitalE1Label", 
  text      : "Digital E1 Physical Configuration",
  helpText  : "e1ParametersdigitalE1",
  style     : 'line-height:40px;'
});

var framingE1_select = new Ext.form.ComboBox({
  id              : 'framingE1_selection',
  name            : 'framing',
  fieldLabel      : "Framing",
  helpText        : "e1ParametersdigitalE1framing",
  store           : ['CRC4','NonCRC4'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

var line_encE1_select = new Ext.form.ComboBox({
  id              : 'line_encE1_selection',
  name            : 'lineEncoding',
  fieldLabel      : "Line Encoding",
  helpText        : "e1ParametersdigitalE1lineEncoding",
  store           : ['AMI','HDB3'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

var clockingE1_select = new Ext.form.ComboBox({
  id              : 'clockingE1_selection',
  name            : 'clocking',
  fieldLabel      : "Clocking",
  helpText        : "clockingclocking",
  store           : ['TERMINAL','NETWORK'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

var signalingE1_select = new Ext.form.ComboBox({
  id              : 'signalingE1_selection',
  name            : 'E1Signaling',
  fieldLabel      : "Signaling",
  helpText        : "e1ParametersdigitalE1E1Signaling",
  store           : ['CCS','CAS'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145,
  listeners       : {"select":function(){
    isDChannelEnabled.call(dChannelE1_disable);
  }}
});

Ext.Ajax.request({
  url: Paraxip.baseUrl + "getGCParameterValue",
  disableCaching: true,
  params: {"paramName":'netborder.oamWebServer.hideR2Options'},
  success: function(result){
    var response = Ext.util.JSON.decode(result.responseText);
    if( response.paramValue ) {
      signalingE1_select.store.remove(signalingE1_select.store.getAt(1));
    }
  }
});

var terminationE1_select = new Ext.form.ComboBox({
  id              : 'terminationE1_selection',
  name            : 'E1Termination',
  fieldLabel      : "Termination",
  helpText        : "e1ParametersdigitalE1E1Termination",
  store           : ['75ohm','120ohm'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

/*
var loopback_modeE1_select = new Ext.form.ComboBox({
  id              : 'loopback_modeE1_selection',
  name            : 'loopbackMode',
  fieldLabel      : "Loopback Mode",
  helpText        : "e1ParametersdigitalE1loopbackMode",
  store           : ['DISABLED'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});
*/
var dChannelE1_label = new Ext.form.Label({
  id    : "Paraxip.config.physConfig.dchannelE1Label",
  text  : "D-Channel E1 Configuration",
  style : 'line-height:40px;'
});

var dChannelE1_disable = new Ext.form.ComboBox({
  id              : 'disableDChannelE1',
  fieldLabel      : 'Enable/Disable D-Channel',
  name            : 'disableDChannel',
  store           : ['ENABLED','DISABLED'],
  forceSelection  : true,
  triggerAction   : 'all',
  mode            : 'local',
  typeAhead       : true,
  selectOnFocus   : true,
  width           : 145,
  minListWidth    : 145
});

dChannelE1_disable.on('select',isDChannelEnabled,dChannelE1_disable);

// Max value is 31 and Min is 1
var channelE1_idx_text = new Ext.form.TextField({
  id          : 'channelE1_idx_text',
  fieldLabel  : "D-Channel Index",
  name        : "channelIndex",
  helpText    : "e1ParametersdigitalE1DChannelE1channelIndex",
  disabled    : true,
  width       : 162,
  value       : 31
});

// Max is 4096 and min 256
var mtu_sizeE1_text = new Ext.form.NumberField({
  id          : 'mtu_sizeE1_text',
  fieldLabel  : "MTU Size",
  name        : "mtuSize",
  helpText    : "DChannelMtuSizemtuSize",
  value       : 2048,
  width       : 162
});

var record_to_pcap_fileE1 = new Ext.form.ComboBox({
  id              : 'record_to_pcap_fileE1'
  ,fieldLabel     : "Record To PcapFile"
  ,name           : 'RecordToPcapFile'
  ,store          : ['YES','NO']
  ,forceSelection : true
  ,helpText       : "DChannelRecordToPcapFileRecordToPcapFile"
  ,triggerAction  : 'all'
  ,mode           : 'local'
  ,typeAhead      : true
  ,selectOnFocus  : true
  ,width          : 145
  ,minListWidth   : 145
  ,value          : 'NO'
});

var pcap_files_folderE1 = new Ext.form.TextField({
  id          : 'pcap_files_folderE1',
  fieldLabel  : "Pcap Files Folder",
  helpText    : "DChannelPcapFilesFolderPcapFilesFolder",
  name        : "channelIndex",
  disabled    : true,
  width       : 162
});

pcap_files_folderE1.on('render',function(){
  isDChannelEnabled.call(dChannelE1_disable);
  });

var defaultPcmLawE1_select =  createPcmLawSelection({
  id  : 'defaultPcmLawE1_selection'
});

var voicePacketLengthInMsE1_text = createVoicePacketText({
  id  : 'voicePacketLengthInMsE1_text'
});

var  optimalTxBufferLevelE1_text =  createOptimalTxBufferLevelText({
  id  : 'optimalTxBufferLevelE1_text'
});

var toneSetAttributesE1_select = createToneSetAtributesSelection({
  id  : 'toneSetAttributesE1_select'
});

var ecE1_type_select = createEcTypeSelect({
  id  : 'ecE1_type_selection'
});

var ecE1_mode_select = createEcModeSelect({
  id  : 'ecE1_mode_selection'
});

var ecE1_comfortNoiseMode_select = createEcComfortNoiseSelect({
  id  : 'ecE1_comfortNoiseMode_selection'
});

var ecE1_tailDisplacementInMs_text = createEcTailText({
  id  : 'ecE1_tailDisplacementInMs_text'
});

var ecE1_doubleTalkBehavior_select = createEcDoubleTalkSelect({
  id  : 'ecE1_doubleTalkBehavior_selection'
});

var aecE1_type_select = createAecTypeSelect({
  id  : 'aecE1_type_selection'
});

var aecE1_mode_select = createAecModeSelect({
  id  : 'aecE1_mode_selection'
});

var levelE1_type_select = createLevelTypeSelect({
  id  : 'levelE1_type_selection'
});

var levelE1_direction_select = createLevelDirectionSelect({
  id  : 'levelE1_direction_selection'
});

var levelE1_mode_select = createLevelModeSelect({
  id        : 'levelE1_mode_selection',
  listeners : {
    'select': levelControlVisibleFields,
    scope   : frmDigitalE1PhysConf
  }
});

var levelE1_targetLevelIndBM0_text = createLevelTargetText({
  id  : 'levelE1_targetLevelIndBM0_text'
});

var levelE1_gainIndB_text = createLevelGainText({
  id  : 'levelE1_gainIndB_text'
});

var bnaE1_type_select = createBnaTypeSelect({
  id  : 'bnaE1_type_selection'
});

var bnaE1_direction_select = createBnaDirectionSelect({
  id  : 'bnaE1_direction_selection'
});

var bnaE1_mode_select = createBnaModeSelect({
  id  : 'bnaE1_mode_selection'
});

var bnaE1_attenuationIndB_select = createBnaAttenuationSelect({
  id  : 'bnaE1_attenuationIndB_selection'
});

var dtmfE1_type_select = createDtmfTypeSelect({
  id  : 'dtmfE1_type_selection'
});

var dtmfE1_direction_select = createDtmfDirectionSelect({
  id  : 'dtmfE1_direction_selection'
});

var dtmfE1_mode_select = createDtmfModeSelect({
  id  : 'dtmfE1_mode_selection'
});

e1ConfigPanel.add(id_textE1);
e1ConfigPanel.add(name_textE1);
frmDigitalE1PhysConf.add(e1ConfigPanel);

//frmDigitalE1PhysConf.add(digitalE1_label);
digitalE1Panel.add(framingE1_select);
digitalE1Panel.add(line_encE1_select);
digitalE1Panel.add(clockingE1_select);
digitalE1Panel.add(signalingE1_select);
digitalE1Panel.add(terminationE1_select);
frmDigitalE1PhysConf.add(digitalE1Panel);
//frmDigitalE1PhysConf.add(loopback_modeE1_select);

//frmDigitalE1PhysConf.add(dChannelE1_label);
DChannelE1Panel.add(dChannelE1_disable);
DChannelE1Panel.add(channelE1_idx_text);
DChannelE1Panel.add(mtu_sizeE1_text);
DChannelE1Panel.add(record_to_pcap_fileE1);
DChannelE1Panel.add(pcap_files_folderE1);
frmDigitalE1PhysConf.add(DChannelE1Panel);

//frmDigitalE1PhysConf.add(createAudioLabel());
audioE1Panel.add(defaultPcmLawE1_select);
audioE1Panel.add(voicePacketLengthInMsE1_text);
audioE1Panel.add(toneSetAttributesE1_select);
audioE1Panel.add(optimalTxBufferLevelE1_text);
frmDigitalE1PhysConf.add(audioE1Panel);

//frmDigitalE1PhysConf.add(createEchoCancelLabel());
echoE1Panel.add(ecE1_type_select);
echoE1Panel.add(ecE1_mode_select);
echoE1Panel.add(ecE1_comfortNoiseMode_select);
echoE1Panel.add(ecE1_tailDisplacementInMs_text);
echoE1Panel.add(ecE1_doubleTalkBehavior_select);
frmDigitalE1PhysConf.add(echoE1Panel);

//frmDigitalE1PhysConf.add(createAcousticLabel());
acousticE1Panel.add(aecE1_type_select);
acousticE1Panel.add(aecE1_mode_select);
frmDigitalE1PhysConf.add(acousticE1Panel);

//frmDigitalE1PhysConf.add(createLevelControlLabel());
levelE1Panel.add(levelE1_type_select);
levelE1Panel.add(levelE1_direction_select);
levelE1Panel.add(levelE1_mode_select);
levelE1Panel.add(levelE1_targetLevelIndBM0_text);
levelE1Panel.add(levelE1_gainIndB_text);
frmDigitalE1PhysConf.add(levelE1Panel);

//frmDigitalE1PhysConf.add(createBackgroundLabel());
backgroundE1Panel.add(bnaE1_type_select);
backgroundE1Panel.add(bnaE1_direction_select);
backgroundE1Panel.add(bnaE1_mode_select);
backgroundE1Panel.add(bnaE1_attenuationIndB_select);
frmDigitalE1PhysConf.add(backgroundE1Panel);

//frmDigitalE1PhysConf.add(createDTMFRemovalLabel());
dtmfE1Panel.add(dtmfE1_type_select);
dtmfE1Panel.add(dtmfE1_direction_select);
dtmfE1Panel.add(dtmfE1_mode_select);
frmDigitalE1PhysConf.add(dtmfE1Panel);

//------------------------------------------------
//Digital Physical J1 Config form
//-----------------------------------------------
Ext.namespace("Paraxip.config.physConfig");

var frmDigitalJ1PhysConf = new Ext.FormPanel({
title         : "Digital Physical Configuration",
frame         : true,
header        : false,
id            : "frmDigitalJ1PhysConf",
autoScroll    : true,
layout        : 'accordion',
layoutConfig  : {
 activeItem  : 0
},
defaults      : {
 layout: 'form',
 style: 'text-align:left;',
 labelWidth: 150,
 bodyStyle: 'padding:5px;',
 width: 500,
 autoHeight: true,
 fill: true
},
buttonAlign   : "right",
buttons       : [{
 id: "Paraxip.config.physConfig.digitalJ1AssignedIf",
 text: 'Assigned interface(s)',
 listeners: {'click':function(){
     configId = id_textJ1.getValue();
     unassignedInterfacesGrid.getStore().load({
        params: {'id':configId}
     });
     assignedInterfacesGrid.getStore().load({
        params: {'id':configId}
     });
     assignInterfacesWindow.show();
   }
 }
},{
 id: "Paraxip.config.physConfig.digitalJ1SaveButton",
 text: 'Save',
 listeners: {'click':saveConfig}
},{
 id: "Paraxip.config.physConfig.digitalJ1CancelButton",
 text: 'Cancel',
 listeners: {'click':physConfCancel}
}]
});

var j1ConfigPanel = new Ext.Panel({
id    : 'J1ConfigPanel',
name  : 'config',
title : 'Configuration Info',
items : [{
 xtype: 'textfield',
 id: 'j1NodeId',
 name: 'nodeId',
 hidden: true,
 hideLabel: true
}]
});

var digitalJ1Panel = new ParaxipPanelWithHelp({
id    : 'digitalJ1Panel ',
name  : 'digitalJ1',
title : 'Digital J1 Configuration',
helpText : "j1ParametersdigitalJ1"
});

var DChannelJ1Panel = new Ext.Panel({
id    : 'DChannelJ1Panel',
name  : 'DChannelJ1',
title : 'DChannel J1 Configuration'
});

var audioJ1Panel = new Ext.Panel({
id    : 'audioJ1Panel',
name  : 'audio',
title : 'Audio Configuration'
});

var echoJ1Panel = new ParaxipPanelWithHelp({
id    : 'echoJ1Panel',
name  : 'EchoCancellation',
title : 'Echo Cancellation Configuration',
helpText: "HardwareEchoCancellationEchoCancellation"
});

var acousticJ1Panel = new ParaxipPanelWithHelp({
id    : 'acousticJ1Panel',
name  : 'AcousticEchoCancellation',
title : 'Acoustic Echo Cancellation Configuration',
helpText: "HardwareAcousticEchoCancellationAcousticEchoCancellation"
});

var levelJ1Panel = new ParaxipPanelWithHelp({
id    : 'levelJ1Panel',
name  : 'LevelControl',
title : 'Level Control Configuration',
helpText: "HardwareLevelControlLevelControl"
});

var backgroundJ1Panel = new ParaxipPanelWithHelp({
id    : 'backgroundJ1Panel',
name  : 'BackgroundNoiseAttenuation',
title : 'Background Noise Attenuation Configuration',
helpText: "HardwareBackgroundNoiseRemovalBackgroundNoiseAttenuation"
});

var dtmfJ1Panel = new ParaxipPanelWithHelp({
id    : 'dtmfJ1Panel',
name  : 'DTMFRemoval',
title : 'DTMF Removal Configuration',
helpText: "HardwareDTMFRemovalDTMFRemoval"
});

/**************************
Digital J1 Configuration
***************************/

var id_textJ1 = new Ext.form.TextField({
id          : 'id_textJ1',
fieldLabel  : "ID",
name        : "id",
disabled    : true,
width       : 162
});

var name_textJ1 = new Ext.form.TextField({
id          : 'name_textJ1',
fieldLabel  : "Display Name",
name        : "displayName",
width       : 162
});

var digitalJ1_label = new Ext.form.Label({
id        : "Paraxip.config.physConfig.digitalJ1Label",
text      : "Digital J1 Physical Configuration",
helpText  : "j1ParametersdigitalJ1",
style     : 'line-height:40px;'
});

var framingJ1_select = new Ext.form.ComboBox({
id              : 'framingJ1_selection',
name            : 'framing',
fieldLabel      : "Framing",
helpText        : "j1ParametersdigitalJ1framing",
store           : ['ESF',/*'ESF_Japan',*/'D4'], //ESF_Japan not supported for now
forceSelection  : true,
triggerAction   : 'all',
mode            : 'local',
typeAhead       : true,
selectOnFocus   : true,
width           : 145,
minListWidth    : 145
});

var line_encJ1_select = new Ext.form.ComboBox({
id              : 'line_encJ1_selection',
name            : 'lineEncoding',
fieldLabel      : "Line Encoding",
helpText        : "j1ParametersdigitalJ1lineEncoding",
store           : ['AMI','B8ZS'],
forceSelection  : true,
triggerAction   : 'all',
mode            : 'local',
typeAhead       : true,
selectOnFocus   : true,
width           : 145,
minListWidth    : 145
});

var lboJ1_select = new Ext.form.ComboBox({
id              : 'lboJ1_selection',
name            : 'LBO',
fieldLabel      : "LBO",
helpText        : "j1ParametersdigitalJ1LBO",
store           : ['0dB','-7.5dB','-15dB','-22.5dB',
                  '0-110feet','110-220feet','220-330feet',
                  '330-440feet','440-550feet','550-660feet'],
forceSelection  : true,
triggerAction   : 'all',
mode            : 'local',
typeAhead       : true,
selectOnFocus   : true,
width           : 145,
minListWidth    : 145
});

var clockingJ1_select = new Ext.form.ComboBox({
id              : 'clockingJ1_selection',
name            : 'clocking',
fieldLabel      : "Clocking",
helpText        : "clockingclocking",
store           : ['TERMINAL','NETWORK'],
forceSelection  : true,
triggerAction   : 'all',
mode            : 'local',
typeAhead       : true,
selectOnFocus   : true,
disabled        : false,
width           : 145,
minListWidth    : 145
});

var dChannelJ1_label = new Ext.form.Label({
id      : "Paraxip.config.physConfig.dchannelJ1Label"
,text   : "D-Channel J1 Configuration"
,style  : 'line-height:40px;'
});

var dChannelJ1_disable = new Ext.form.ComboBox({
id                : 'disableDChannelJ1'
,fieldLabel       : 'Enable/Disable D-Channel'
,name             : 'disableDChannel'
,store            : ['ENABLED','DISABLED']
,forceSelection   : true
,triggerAction    : 'all'
,mode             : 'local'
,typeAhead        : true
,selectOnFocus    : true
,width            : 145
,minListWidth     : 145
});

dChannelJ1_disable.on('select',isDChannelEnabled,dChannelJ1_disable);

//Max value is 24 and Min is 1
var channelJ1_idx_text = new Ext.form.TextField({
id            : 'channelJ1_idx_text'
,fieldLabel   : "D-Channel Index"
,helpText     : "j1ParametersdigitalJ1DChannelJ1channelIndex"
,name         : "channelIndex"
,helpText     : "j1ParametersdigitalJ1DChannelJ1channelIndex"
,disabled     : true
,width        : 162
,value        : 24
});

//Max is 4096 and min 256
var mtu_sizeJ1_text = new Ext.form.NumberField({
id            : 'mtu_sizeJ1_text'
,fieldLabel   : "MTU Size"
,name         : "mtuSize"
,helpText     : "DChannelMtuSizemtuSize"
,value        : 2048
,width        : 162
});

var record_to_pcap_fileJ1 = new Ext.form.ComboBox({
id                : 'record_to_pcap_fileJ1'
,fieldLabel       : "Record To Pcap File"
,name             : 'RecordToPcapFile'
,store            : ['YES','NO']
,forceSelection   : true
,helpText         : "DChannelRecordToPcapFileRecordToPcapFile"
,triggerAction    : 'all'
,mode             : 'local'
,typeAhead        : true
,selectOnFocus    : true
,width            : 145
,minListWidth     : 145
,value            : 'NO'
});

var pcap_files_folderJ1 = new Ext.form.TextField({
id            : 'pcap_files_folderJ1'
,fieldLabel   : "Pcap Files Folder"
,helpText     : "DChannelPcapFilesFolderPcapFilesFolder"
,name         : "pcap_files_folderJ1"
,disabled     : true
,width        : 162
,value        : "/logs/dchan-pcap-recording/"
});

pcap_files_folderJ1.on('render',function(){
isDChannelEnabled.call(dChannelJ1_disable);
});

var defaultPcmLawJ1_select =  createPcmLawSelection({
id  : 'defaultPcmLawJ1_selection'
});

var voicePacketLengthInMsJ1_text = createVoicePacketText({
id  : 'voicePacketLengthInMsJ1_text'
});

var optimalTxBufferLevelJ1_text = createOptimalTxBufferLevelText({
id  : 'optimalTxBufferLevelJ1_text'
});

var toneSetAttributesJ1_select = createToneSetAtributesSelection({
id  : 'toneSetAttributesJ1_select'
});

var ecJ1_type_select = createEcTypeSelect({
id  : 'ecJ1_type_selection'
});

var ecJ1_mode_select = createEcModeSelect({
id  : 'ecJ1_mode_selection'
});

var ecJ1_comfortNoiseMode_select = createEcComfortNoiseSelect({
id  : 'ecJ1_comfortNoiseMode_selection'
});

var ecJ1_tailDisplacementInMs_text = createEcTailText({
id  : 'ecJ1_tailDisplacementInMs_text'
});

var ecJ1_doubleTalkBehavior_select = createEcDoubleTalkSelect({
id  : 'ecJ1_doubleTalkBehavior_selection'
});

var aecJ1_type_select = createAecTypeSelect({
id  : 'aecJ1_type_selection'
});

var aecJ1_mode_select = createAecModeSelect({
id  : 'aecJ1_mode_selection'
});

var levelJ1_type_select = createLevelTypeSelect({
id  : 'levelJ1_type_selection'
});

var levelJ1_direction_select = createLevelDirectionSelect({
id  : 'levelJ1_direction_selection'
});

var levelJ1_mode_select = createLevelModeSelect({
id        : 'levelJ1_mode_selection',
listeners : {
 'select': levelControlVisibleFields,
 scope   : frmDigitalJ1PhysConf
}
});

var levelJ1_targetLevelIndBM0_text = createLevelTargetText({
id  : 'levelJ1_targetLevelIndBM0_text'
});

var levelJ1_gainIndB_text = createLevelGainText({
id  : 'levelJ1_gainIndB_text'
});

var bnaJ1_type_select = createBnaTypeSelect({
id  : 'bnaJ1_type_selection'
});

var bnaJ1_direction_select = createBnaDirectionSelect({
id  : 'bnaJ1_direction_selection'
});

var bnaJ1_mode_select = createBnaModeSelect({
id  : 'bnaJ1_mode_selection'
});

var bnaJ1_attenuationIndB_select = createBnaAttenuationSelect({
id  : 'bnaJ1_attenuationIndB_selection'
});

var dtmfJ1_type_select = createDtmfTypeSelect({
id  : 'dtmfJ1_type_selection'
});

var dtmfJ1_direction_select = createDtmfDirectionSelect({
id  : 'dtmfJ1_direction_selection'
});

var dtmfJ1_mode_select = createDtmfModeSelect({
id  : 'dtmfJ1_mode_selection'
});

j1ConfigPanel.add(id_textJ1);
j1ConfigPanel.add(name_textJ1);
frmDigitalJ1PhysConf.add(j1ConfigPanel);

//frmDigitalJ1PhysConf.add(digitalJ1_label);
digitalJ1Panel.add(framingJ1_select);
digitalJ1Panel.add(line_encJ1_select);
digitalJ1Panel.add(lboJ1_select);
digitalJ1Panel.add(clockingJ1_select);
//digitalJ1Panel.add(loopback_modeJ1_select);
frmDigitalJ1PhysConf.add(digitalJ1Panel);

//frmDigitalJ1PhysConf.add(dChannelJ1_label);
DChannelJ1Panel.add(dChannelJ1_disable);
DChannelJ1Panel.add(channelJ1_idx_text);
DChannelJ1Panel.add(mtu_sizeJ1_text);
DChannelJ1Panel.add(record_to_pcap_fileJ1);
DChannelJ1Panel.add(pcap_files_folderJ1);
frmDigitalJ1PhysConf.add(DChannelJ1Panel);

//frmDigitalJ1PhysConf.add(createAudioLabel());
audioJ1Panel.add(defaultPcmLawJ1_select);
audioJ1Panel.add(voicePacketLengthInMsJ1_text);
audioJ1Panel.add(toneSetAttributesJ1_select);
audioJ1Panel.add(optimalTxBufferLevelJ1_text);
frmDigitalJ1PhysConf.add(audioJ1Panel);

//frmDigitalJ1PhysConf.add(createEchoCancelLabel());
echoJ1Panel.add(ecJ1_type_select);
echoJ1Panel.add(ecJ1_mode_select);
echoJ1Panel.add(ecJ1_comfortNoiseMode_select);
echoJ1Panel.add(ecJ1_tailDisplacementInMs_text);
echoJ1Panel.add(ecJ1_doubleTalkBehavior_select);
frmDigitalJ1PhysConf.add(echoJ1Panel);

//frmDigitalJ1PhysConf.add(createAcousticLabel());
acousticJ1Panel.add(aecJ1_type_select);
acousticJ1Panel.add(aecJ1_mode_select);
frmDigitalJ1PhysConf.add(acousticJ1Panel);

//frmDigitalJ1PhysConf.add(createLevelControlLabel());
levelJ1Panel.add(levelJ1_type_select);
levelJ1Panel.add(levelJ1_direction_select);
levelJ1Panel.add(levelJ1_mode_select);
levelJ1Panel.add(levelJ1_targetLevelIndBM0_text);
levelJ1Panel.add(levelJ1_gainIndB_text);
frmDigitalJ1PhysConf.add(levelJ1Panel);

//frmDigitalJ1PhysConf.add(createBackgroundLabel());
backgroundJ1Panel.add(bnaJ1_type_select);
backgroundJ1Panel.add(bnaJ1_direction_select);
backgroundJ1Panel.add(bnaJ1_mode_select);
backgroundJ1Panel.add(bnaJ1_attenuationIndB_select);
frmDigitalJ1PhysConf.add(backgroundJ1Panel);

//frmDigitalJ1PhysConf.add(createDTMFRemovalLabel());
dtmfJ1Panel.add(dtmfJ1_type_select);
dtmfJ1Panel.add(dtmfJ1_direction_select);
dtmfJ1Panel.add(dtmfJ1_mode_select);
frmDigitalJ1PhysConf.add(dtmfJ1Panel);

//------------------------------------------------
//Digital Physical BRI Config form
//-----------------------------------------------
Ext.namespace("Paraxip.config.physConfig");

var frmDigitalBRIPhysConf = new Ext.FormPanel({
title         : "Digital Physical Configuration",
frame         : true,
header        : false,
id            : "frmDigitalBRIPhysConf",
autoScroll    : true,
layout        : 'accordion',
layoutConfig  : {
 activeItem  : 0
},
defaults      : {
 layout: 'form',
 style: 'text-align:left;',
 labelWidth: 150,
 bodyStyle: 'padding:5px;',
 width: 500,
 autoHeight: true,
 fill: true
},
buttonAlign   : "right",
buttons       : [{
 id: "Paraxip.config.physConfig.digitalBRIAssignedIf",
 text: 'Assigned interface(s)',
 listeners: {'click':function(){
     configId = id_textBRI.getValue();
     unassignedInterfacesGrid.getStore().load({
        params: {'id':configId}
     });
     assignedInterfacesGrid.getStore().load({
        params: {'id':configId}
     });
     assignInterfacesWindow.show();
   }
 }
},{
 id: "Paraxip.config.physConfig.digitalBRISaveButton",
 text: 'Save',
 listeners: {'click':saveConfig}
},{
 id: "Paraxip.config.physConfig.digitalBRICancelButton",
 text: 'Cancel',
 listeners: {'click':physConfCancel}
}]
});

var briConfigPanel = new Ext.Panel({
id    : 'briConfigPanel',
name  : 'config',
title : 'Configuration Info',
items : [{
 xtype: 'textfield',
 id: 'briNodeId',
 name: 'nodeId',
 hidden: true,
 hideLabel: true
}]
});

var digitalBRIPanel = new ParaxipPanelWithHelp({
id    : 'digitalBRIPanel ',
name  : 'digitalBRI',
title : 'Digital BRI Configuration',
helpText : "briParametersdigitalBRI"
});

var DChannelBRIPanel = new Ext.Panel({
id    : 'DChannelBRIPanel',
name  : 'DChannelBRI',
title : 'DChannel BRI Configuration'
});

var audioBRIPanel = new Ext.Panel({
id    : 'audioBRIPanel',
name  : 'audio',
title : 'Audio Configuration'
});

var echoBRIPanel = new ParaxipPanelWithHelp({
id    : 'echoBRIPanel',
name  : 'EchoCancellation',
title : 'Echo Cancellation Configuration',
helpText: "HardwareEchoCancellationEchoCancellation"
});

var acousticBRIPanel = new ParaxipPanelWithHelp({
id    : 'acousticBRIPanel',
name  : 'AcousticEchoCancellation',
title : 'Acoustic Echo Cancellation Configuration',
helpText: "HardwareAcousticEchoCancellationAcousticEchoCancellation"
});

var levelBRIPanel = new ParaxipPanelWithHelp({
id    : 'levelBRIPanel',
name  : 'LevelControl',
title : 'Level Control Configuration',
helpText: "HardwareLevelControlLevelControl"
});

var backgroundBRIPanel = new ParaxipPanelWithHelp({
id    : 'backgroundBRIPanel',
name  : 'BackgroundNoiseAttenuation',
title : 'Background Noise Attenuation Configuration',
helpText: "HardwareBackgroundNoiseRemovalBackgroundNoiseAttenuation"
});

var dtmfBRIPanel = new ParaxipPanelWithHelp({
id    : 'dtmfBRIPanel',
name  : 'DTMFRemoval',
title : 'DTMF Removal Configuration',
helpText: "HardwareDTMFRemovalDTMFRemoval"
});

/**************************
Digital BRI Configuration
***************************/

var id_textBRI = new Ext.form.TextField({
id          : 'id_textBRI',
fieldLabel  : "ID",
name        : "id",
disabled    : true,
width       : 162
});

var name_textBRI = new Ext.form.TextField({
id          : 'name_textBRI',
fieldLabel  : "Display Name",
name        : "displayName",
width       : 162
});

var digitalBRI_label = new Ext.form.Label({
id        : "Paraxip.config.physConfig.digitalBRILabel",
text      : "Digital BRI Physical Configuration",
helpText  : "briParametersdigitalBRI",
style     : 'line-height:40px;'
});


var lboBRI_select = new Ext.form.ComboBox({
id              : 'lboBRI_selection',
name            : 'LBO',
fieldLabel      : "LBO",
helpText        : "briParametersdigitalBRILBO",
store           : ['0dB'],
forceSelection  : true,
triggerAction   : 'all',
mode            : 'local',
typeAhead       : true,
selectOnFocus   : true,
width           : 145,
minListWidth    : 145
});

var clockingBRI_select = new Ext.form.ComboBox({
id              : 'clockingBRI_selection',
name            : 'clocking',
fieldLabel      : "Clocking",
helpText        : "clockingclocking",
store           : ['TERMINAL','NETWORK'],
forceSelection  : true,
triggerAction   : 'all',
mode            : 'local',
typeAhead       : true,
selectOnFocus   : true,
disabled        : false,
width           : 145,
minListWidth    : 145
});

var signalingBRI_select = new Ext.form.ComboBox({
id              : 'signalingBRI_selection',
name            : 'BRISignaling',
fieldLabel      : "Signaling",
helpText        : "briParametersdigitalBRISignaling",
store           : ['CCS'],
disabled        : true,
forceSelection  : true,
triggerAction   : 'all',
mode            : 'local',
typeAhead       : true,
selectOnFocus   : true,
width           : 145,
minListWidth    : 145
});

var dChannelBRI_label = new Ext.form.Label({
id      : "Paraxip.config.physConfig.dchannelBRILabel"
,text   : "D-Channel BRI Configuration"
,style  : 'line-height:40px;'
});

var dChannelBRI_disable = new Ext.form.ComboBox({
id                : 'disableDChannelBRI'
,fieldLabel       : 'Enable/Disable D-Channel'
,name             : 'disableDChannel'
,store            : ['ENABLED','DISABLED']
,forceSelection   : true
,triggerAction    : 'all'
,mode             : 'local'
,typeAhead        : true
,selectOnFocus    : true
,width            : 145
,minListWidth     : 145
});

dChannelBRI_disable.on('select',isDChannelEnabled,dChannelBRI_disable);

//Max value is 24 and Min is 1
var channelBRI_idx_text = new Ext.form.TextField({
id            : 'channelBRI_idx_text'
,fieldLabel   : "D-Channel Index"
,helpText     : "briParametersdigitalBRIDChannelBRIchannelIndex"
,name         : "channelIndex"
,helpText     : "briParametersdigitalBRIDChannelBRIchannelIndex"
,disabled     : true
,width        : 162
,value        : 24
});

//Max is 4096 and min 256
var mtu_sizeBRI_text = new Ext.form.NumberField({
id            : 'mtu_sizeBRI_text'
,fieldLabel   : "MTU Size"
,name         : "mtuSize"
,helpText     : "DChannelMtuSizemtuSize"
,value        : 2048
,width        : 162
});

var record_to_pcap_fileBRI = new Ext.form.ComboBox({
id                : 'record_to_pcap_fileBRI'
,fieldLabel       : "Record To Pcap File"
,name             : 'RecordToPcapFile'
,store            : ['YES','NO']
,forceSelection   : true
,helpText         : "DChannelRecordToPcapFileRecordToPcapFile"
,triggerAction    : 'all'
,mode             : 'local'
,typeAhead        : true
,selectOnFocus    : true
,width            : 145
,minListWidth     : 145
,value            : 'NO'
});

var pcap_files_folderBRI = new Ext.form.TextField({
id            : 'pcap_files_folderBRI'
,fieldLabel   : "Pcap Files Folder"
,helpText     : "DChannelPcapFilesFolderPcapFilesFolder"
,name         : "pcap_files_folderBRI"
,disabled     : true
,width        : 162
,value        : "/logs/dchan-pcap-recording/"
});

pcap_files_folderBRI.on('render',function(){
isDChannelEnabled.call(dChannelBRI_disable);
});

var defaultPcmLawBRI_select =  createPcmLawSelection({
id  : 'defaultPcmLawBRI_selection'
});

var voicePacketLengthInMsBRI_text = createVoicePacketText({
id  : 'voicePacketLengthInMsBRI_text'
});

var optimalTxBufferLevelBRI_text = createOptimalTxBufferLevelText({
id  : 'optimalTxBufferLevelBRI_text'
});

var toneSetAttributesBRI_select = createToneSetAtributesSelection({
id  : 'toneSetAttributesBRI_select'
});

var ecBRI_type_select = createEcTypeSelect({
id  : 'ecBRI_type_selection'
});

var ecBRI_mode_select = createEcModeSelect({
id  : 'ecBRI_mode_selection'
});

var ecBRI_comfortNoiseMode_select = createEcComfortNoiseSelect({
id  : 'ecBRI_comfortNoiseMode_selection'
});

var ecBRI_tailDisplacementInMs_text = createEcTailText({
id  : 'ecBRI_tailDisplacementInMs_text'
});

var ecBRI_doubleTalkBehavior_select = createEcDoubleTalkSelect({
id  : 'ecBRI_doubleTalkBehavior_selection'
});

var aecBRI_type_select = createAecTypeSelect({
id  : 'aecBRI_type_selection'
});

var aecBRI_mode_select = createAecModeSelect({
id  : 'aecBRI_mode_selection'
});

var levelBRI_type_select = createLevelTypeSelect({
id  : 'levelBRI_type_selection'
});

var levelBRI_direction_select = createLevelDirectionSelect({
id  : 'levelBRI_direction_selection'
});

var levelBRI_mode_select = createLevelModeSelect({
id        : 'levelBRI_mode_selection',
listeners : {
 'select': levelControlVisibleFields,
 scope   : frmDigitalBRIPhysConf
}
});

var levelBRI_targetLevelIndBM0_text = createLevelTargetText({
id  : 'levelBRI_targetLevelIndBM0_text'
});

var levelBRI_gainIndB_text = createLevelGainText({
id  : 'levelBRI_gainIndB_text'
});

var bnaBRI_type_select = createBnaTypeSelect({
id  : 'bnaBRI_type_selection'
});

var bnaBRI_direction_select = createBnaDirectionSelect({
id  : 'bnaBRI_direction_selection'
});

var bnaBRI_mode_select = createBnaModeSelect({
id  : 'bnaBRI_mode_selection'
});

var bnaBRI_attenuationIndB_select = createBnaAttenuationSelect({
id  : 'bnaBRI_attenuationIndB_selection'
});

var dtmfBRI_type_select = createDtmfTypeSelect({
id  : 'dtmfBRI_type_selection'
});

var dtmfBRI_direction_select = createDtmfDirectionSelect({
id  : 'dtmfBRI_direction_selection'
});

var dtmfBRI_mode_select = createDtmfModeSelect({
id  : 'dtmfBRI_mode_selection'
});

briConfigPanel.add(id_textBRI);
briConfigPanel.add(name_textBRI);
frmDigitalBRIPhysConf.add(briConfigPanel);

//frmDigitalBRIPhysConf.add(digitalBRI_label);
digitalBRIPanel.add(lboBRI_select);
digitalBRIPanel.add(clockingBRI_select);
digitalBRIPanel.add(signalingBRI_select);
//digitalBRIPanel.add(loopback_modeBRI_select);
frmDigitalBRIPhysConf.add(digitalBRIPanel);

//frmDigitalBRIPhysConf.add(dChannelBRI_label);
DChannelBRIPanel.add(dChannelBRI_disable);
DChannelBRIPanel.add(channelBRI_idx_text);
DChannelBRIPanel.add(mtu_sizeBRI_text);
DChannelBRIPanel.add(record_to_pcap_fileBRI);
DChannelBRIPanel.add(pcap_files_folderBRI);
frmDigitalBRIPhysConf.add(DChannelBRIPanel);

//frmDigitalBRIPhysConf.add(createAudioLabel());
audioBRIPanel.add(defaultPcmLawBRI_select);
audioBRIPanel.add(voicePacketLengthInMsBRI_text);
audioBRIPanel.add(toneSetAttributesBRI_select);
audioBRIPanel.add(optimalTxBufferLevelBRI_text);
frmDigitalBRIPhysConf.add(audioBRIPanel);

//frmDigitalBRIPhysConf.add(createEchoCancelLabel());
echoBRIPanel.add(ecBRI_type_select);
echoBRIPanel.add(ecBRI_mode_select);
echoBRIPanel.add(ecBRI_comfortNoiseMode_select);
echoBRIPanel.add(ecBRI_tailDisplacementInMs_text);
echoBRIPanel.add(ecBRI_doubleTalkBehavior_select);
frmDigitalBRIPhysConf.add(echoBRIPanel);

//frmDigitalBRIPhysConf.add(createAcousticLabel());
acousticBRIPanel.add(aecBRI_type_select);
acousticBRIPanel.add(aecBRI_mode_select);
frmDigitalBRIPhysConf.add(acousticBRIPanel);

//frmDigitalBRIPhysConf.add(createLevelControlLabel());
levelBRIPanel.add(levelBRI_type_select);
levelBRIPanel.add(levelBRI_direction_select);
levelBRIPanel.add(levelBRI_mode_select);
levelBRIPanel.add(levelBRI_targetLevelIndBM0_text);
levelBRIPanel.add(levelBRI_gainIndB_text);
frmDigitalBRIPhysConf.add(levelBRIPanel);

//frmDigitalBRIPhysConf.add(createBackgroundLabel());
backgroundBRIPanel.add(bnaBRI_type_select);
backgroundBRIPanel.add(bnaBRI_direction_select);
backgroundBRIPanel.add(bnaBRI_mode_select);
backgroundBRIPanel.add(bnaBRI_attenuationIndB_select);
frmDigitalBRIPhysConf.add(backgroundBRIPanel);

//frmDigitalBRIPhysConf.add(createDTMFRemovalLabel());
dtmfBRIPanel.add(dtmfBRI_type_select);
dtmfBRIPanel.add(dtmfBRI_direction_select);
dtmfBRIPanel.add(dtmfBRI_mode_select);
frmDigitalBRIPhysConf.add(dtmfBRIPanel);
