//-----------------------------------------------
// FXO calibration wizard form to select interface to calibrate
//-----------------------------------------------
Ext.namespace("Paraxip.config.fxotune");

var fxotune_select_lines_form = new Ext.Panel({
  title       : "FXO Calibration - Interface Selection "
  ,layout     : 'border'
  ,frame      : true
  ,hideMode   : 'offsets'
  ,header     : false
  ,id         : "Paraxip.config.fxotune.select_lines"
  ,items      : [{
    xtype: 'panel'
    ,region: 'west'
    ,layout: 'fit'
    ,margins: '5 0 0 0'
    ,cmargins: '5 5 0 0'
    ,width: 25
    ,height: 400
    ,minSize: 120
  },{
    xtype: 'panel'
    ,region: 'east'
    ,layout: 'fit'
    ,margins: '5 0 0 0'
    ,cmargins: '5 5 0 0'
    ,width: 25
    ,height: 400
    ,minSize: 120
  }]
});

// North panel: Simple description
var fxotuneSelectionDescriptionPanel = new Ext.Panel ({
  id        : 'Paraxip.config.fxotune.descriptionPanel'
  ,region   : 'north'
  ,height   : 60
  ,minSize  : 60
  ,items    : [{}]
});

var fxotuneSelectionDescriptionLabel = new Ext.form.Label({
  id        : "Paraxip.config.fxotune.descLabel"
  ,region   : 'north'
  ,text     : "Select the FXO interfaces to calibrate:"
  ,style    : 'font-size:120%;font-weight:bold; line-height:60px;'
});

fxotuneSelectionDescriptionPanel.add(fxotuneSelectionDescriptionLabel);

// Hide the component that calls this method
var closeHandler = function(){
  this.hide();
};

var nextMsg = new Ext.form.Label({
  id      : "Paraxip.config.fxotune.selection_next_msg"
  ,region : "south"
  ,layout : 'fit'
//  ,text     : "Click on the \"Start Calibration\" button to continue."
  ,style  : "font-size:100%;font-weight:bold; line-height:60px;text-align:" +
            "right;padding-right:15;"
});

//Grid to display added board

var fxotuneSelectionGridsPanel = new Ext.Panel({
  id: "Paraxip.config_fxotune.selectionPanel"
  ,region: "center"
  ,layout: "fit"
});

// Array that contains the stores of intefaces for every bound found on the
// system using netborder-list-boards tool. Used only when hardware detection
// mode is enabled.
Paraxip.config.fxotune.interfacesStoreMap = new Paraxip.Map();




// Specify the store to use in the config object passed to the function
createFxoInterfacesGrid = function( config ) {
  var sm2 = new Ext.grid.ParaxipCheckboxSelectionModel({
    checkOnly: true
  });
  return new Ext.grid.EditorGridPanel(
    Ext.apply({
      layout: 'fit'
      // not brakable spaces tag is required when the rendered title contains
      // spaces to prevent a wrapping in the generated html.
      ,title: 'Select the FXO Interfaces'
      ,header: true
      ,height: 350
      ,width: '100%'
      ,hideMode: "offsets"
      ,selModel: sm2
      ,enableColumnMove: false
      ,enableColumnHide: false
      ,enableColumnResize: false
      ,enableHdMenu: false
      ,columnWidth: .5
      ,columns: [
        sm2
        ,{
          id: "boardName"
          ,header: "Board Name"
          //,width: 25
          ,sortable: false
          ,dataIndex: 'boardName'
          ,css: 'padding-top:5px;padding-bottom:5px;'
        }
        ,{
          id: 'wanpipe'
          ,header: "Wanpipe"
          //,width: 50
          ,sortable: false
          ,dataIndex: 'wanpipe'
          ,css: 'padding-top:5px;padding-bottom:5px;'
        },{
          id: "wanpipeInterface"
          ,header: "Wanpipe Interface"
          //,width: 50
          ,sortable: false
          ,hidden: false
          ,dataIndex: 'wanpipeInterface'
          ,css: 'padding-top:5px;padding-bottom:5px;'
        }
      ]
      ,stripeRows: true
      ,autoExpandColumn: 'boardName'
      ,viewConfig: {forcefit:true}
      ,listeners: {
        render:function(){
          // Temporary until I find a way to load interfaces with select all
          // (solution copied from QuickSetup-HardwareSelection)
          var index = this.getColumnModel().getIndexById('checker');
          var hd = Ext.fly(this.getView().getHeaderCell(index));
          hd.hide();
      }}
    },config)
  );
};

createFxoInterfacesStore = function(config) {
  return new Ext.data.JsonStore( Ext.apply({
    url: Paraxip.baseUrl + "config/getFxoInterfaces"
    ,autoLoad: true
    ,root: 'data'
    ,idProperty: 'id'
    ,fields: ['boardName','wanpipe','wanpipeInterface']
  }, config));
};

var Paraxip_config_fxotune_interfacesStore = createFxoInterfacesStore({
  id: "Paraxip_config_fxotune_interfacesStore"
  ,baseParams: {"isInWizard":true}
});

fxoInterfacesGrid =
    createFxoInterfacesGrid({
    id      : "Paraxip.config.fxotune.availableInterfacesGrid"
    ,store  : Paraxip_config_fxotune_interfacesStore
    ,style  : 'text-align:left;padding:0 0 0 5px'
    });

fxotuneSelectionGridsPanel.add( fxoInterfacesGrid );


fxotune_select_lines_form.add( fxotuneSelectionDescriptionPanel );
fxotune_select_lines_form.add( fxotuneSelectionGridsPanel );
//fxotune_select_lines_form.add( nextMsg );
