//-----------------------------------------------
// Wizard analog form
//-----------------------------------------------
Ext.namespace("Paraxip.wizard");

var services_form = new Ext.Panel({
  title     : "Services Configuration",
  layout    : 'form',
  frame     : true,
  header    : false,
  id        : "Paraxip.wizard.services_form",
  items     : [{}],
  bodyStyle : 'text-align:left;padding-left:15px;'
});

var ServicesLabel = new Ext.form.Label({
  id    : "Paraxip.wizard.ServicesLabel",
  text  : "Select your services configuration",
  style : 'font-size:120%;font-weight:bold; line-height:60px;'
});

Paraxip.wizard.autoStartGW = new Ext.form.Checkbox({
  id          : "Paraxip.wizard.autoStartGW",
  boxLabel    : "Automatically start gateway at startup",
  hideLabel   : true,
  name        : "autoStartGW",
  checked     : true,
  listeners   : {
    'check':function(){
      Paraxip.status.controls.autoStartGW.setValue(this.getValue())
    }
    ,'render':function(){
      if (isGatewayInCLI) {
        this.setValue(false);
        this.setDisabled(true);
      }
    }
  }
});

Paraxip.wizard.failureAutoStartGW = new Ext.form.Checkbox({
  id          : "Paraxip.wizard.failureAutoStartGW",
  boxLabel    : "Automatically restart gateway in case of failure",
  hideLabel   : true,
  name        : "failureAutoStartGW",
  checked     : true,
  listeners   : {
    'check':function(){
      Paraxip.status.controls.failureAutoStartGW.setValue(this.getValue())
    }
    ,'render':function(){
      if (isGatewayInCLI) {
        this.setValue(false);
        this.setDisabled(true);
      }
    }
  }
});

services_form.add(ServicesLabel);
services_form.add(Paraxip.wizard.autoStartGW);
services_form.add(Paraxip.wizard.failureAutoStartGW);

